//---------------------------------------------------------------------------
#include "CP_reg.h"
#include "CP_cfg.h"
#include "Plugin.hpp"
#include "CP_plug.h"
#include "CP_lng.h"
#include <stdio.h>
//---------------------------------------------------------------------------

TConfigOptions Options;

//---------------------------------------------------------------------------
typedef struct
{
  unsigned char Type;
  unsigned char X1,Y1,X2,Y2;
  unsigned char Focus;
  unsigned int Selected;
  unsigned int Flags;
  unsigned char DefaultButton;
  char *Data;
}TInitDialogItem;
//---------------------------------------------------------------------------
void InitDialogItems(TInitDialogItem *Init, FarDialogItem *Item, int ItemsNumber)
{
  for (int i = 0; i < ItemsNumber; i++)
  {
    Item[i].Type = Init[i].Type;
    Item[i].X1 = Init[i].X1;
    Item[i].Y1 = Init[i].Y1;
    Item[i].X2 = Init[i].X2;
    Item[i].Y2 = Init[i].Y2;
    Item[i].Focus = Init[i].Focus;
    Item[i].Selected = Init[i].Selected;
    Item[i].Flags = Init[i].Flags;
    Item[i].DefaultButton = Init[i].DefaultButton;
    if((unsigned int)Init[i].Data < 2000)
      strcpy(Item[i].Data, GetMsg((unsigned int)Init[i].Data));
    else
      strcpy(Item[i].Data, Init[i].Data);
  }
}
//---------------------------------------------------------------------------
int Config()
{
  TInitDialogItem InitItems[]={
    { DI_DOUBLEBOX, 3, 1, 72, 8, 0, 0, 0, 0, (char *)MConfigTitle },
    { DI_CHECKBOX, 5, 2, 0, 0, 0, 0, 0, 0, (char *)MConfigAddToDisksMenu },
    { DI_FIXEDIT, 7, 3, 7, 3, 1, 0, 0, 0, "" },
    { DI_TEXT, 9, 3, 0, 0, 0, 0, 0, 0, (char *)MConfigDisksMenuDigit },
    { DI_TEXT, 5, 4, 0, 0, 0, 0, DIF_BOXCOLOR | DIF_SEPARATOR, 0, "" },
    { DI_CHECKBOX,5,5,0,0,0,0,0,0,(char *)MConfigUseControlIni },
    { DI_TEXT, 5, 6, 0, 0, 0, 0, DIF_BOXCOLOR | DIF_SEPARATOR, 0, "" },
    { DI_BUTTON, 0, 7, 0, 0, 0, 0, DIF_CENTERGROUP, 1, (char *)MOk },
    { DI_BUTTON, 0, 7, 0, 0, 0, 0, DIF_CENTERGROUP, 0, (char *)MCancel }
  };

  FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];

  InitDialogItems(InitItems, DialogItems, sizeof(InitItems)/sizeof(InitItems[0]));

  DialogItems[1].Selected = Options.AddToDisksMenu;
  if(Options.DisksMenuDigit)
    sprintf(DialogItems[2].Data, "%d", Options.DisksMenuDigit);
  DialogItems[5].Selected = GetRegKey(HKEY_CURRENT_USER, "", "UseControlIni", 0);

  int ExitCode = g_StartupInfo.Dialog(g_StartupInfo.ModuleNumber, -1, -1, 76, 10, "CP_Cfg", DialogItems, sizeof(DialogItems)/sizeof(DialogItems[0]));

  if(ExitCode == -1)
    return FALSE;

  Options.AddToDisksMenu = DialogItems[1].Selected;
  Options.DisksMenuDigit = atoi(DialogItems[2].Data);
  Options.UseControlIni = DialogItems[5].Selected;
  SetRegKey(HKEY_CURRENT_USER, "", "AddToDisksMenu", Options.AddToDisksMenu);
  SetRegKey(HKEY_CURRENT_USER, "", "DisksMenuDigit", Options.DisksMenuDigit);
  SetRegKey(HKEY_CURRENT_USER, "", "UseControlIni", Options.UseControlIni);

  return TRUE;
}
//---------------------------------------------------------------------------
