//---------------------------------------------------------------------------
#include "CP_reg.h"
#include <mem.h>
#include <stdio.h>
#include "CP_plug.h"
//---------------------------------------------------------------------------
void SetRegKey(HKEY hRoot, char* Key, char* ValueName, char* ValueData)
{
  HKEY hKey = CreateRegKey(hRoot, Key);
  RegSetValueEx(hKey, ValueName, 0, REG_SZ, (BYTE*)ValueData, strlen(ValueData) + 1);
  RegCloseKey(hKey);
}
//---------------------------------------------------------------------------
void SetRegKey(HKEY hRoot, char*Key, char* ValueName, DWORD ValueData)
{
  HKEY hKey = CreateRegKey(hRoot, Key);
  RegSetValueEx(hKey, ValueName, 0, REG_DWORD, (BYTE*)&ValueData, sizeof(ValueData));
  RegCloseKey(hKey);
}
//---------------------------------------------------------------------------
void SetRegKey(HKEY hRoot, char* Key, char*ValueName, BYTE*ValueData, DWORD ValueSize)
{
  HKEY hKey = CreateRegKey(hRoot, Key);
  RegSetValueEx(hKey, ValueName, 0, REG_BINARY, ValueData, ValueSize);
  RegCloseKey(hKey);
}
//---------------------------------------------------------------------------
int GetRegKey(HKEY hRoot, char* Key, char* ValueName, char* ValueData, char* Default, DWORD DataSize)
{
  HKEY hKey = OpenRegKey(hRoot, Key);
  DWORD Type;
  int ExitCode = RegQueryValueEx(hKey, ValueName, 0, &Type, (BYTE*)ValueData, &DataSize);
  RegCloseKey(hKey);
  if(hKey == NULL || ExitCode != ERROR_SUCCESS)
  {
    strcpy(ValueData, Default);
    return FALSE;
  }
  return TRUE;
}
//---------------------------------------------------------------------------
int GetRegKey(HKEY hRoot, char* Key, char* ValueName, int &ValueData, DWORD Default)
{
  HKEY hKey = OpenRegKey(hRoot, Key);
  DWORD Type, Size = sizeof(ValueData);
  int ExitCode = RegQueryValueEx(hKey, ValueName, 0, &Type, (BYTE*)&ValueData, &Size);
  RegCloseKey(hKey);
  if(hKey == NULL || ExitCode != ERROR_SUCCESS)
  {
    ValueData = Default;
    return FALSE;
  }
  return TRUE;
}
//---------------------------------------------------------------------------
int GetRegKey(HKEY hRoot, char* Key, char* ValueName, DWORD Default)
{
  int ValueData;
  GetRegKey(hRoot, Key, ValueName, ValueData, Default);
  return ValueData;
}
//---------------------------------------------------------------------------
int GetRegKey(HKEY hRoot, char* Key, char* ValueName, BYTE* ValueData, BYTE* Default, DWORD DataSize)
{
  HKEY hKey = OpenRegKey(hRoot, Key);
  DWORD Type;
  int ExitCode = RegQueryValueEx(hKey, ValueName, 0, &Type, ValueData, &DataSize);
  RegCloseKey(hKey);
  if(hKey == NULL || ExitCode != ERROR_SUCCESS)
  {
    if(Default != NULL)
      memcpy(ValueData, Default, DataSize);
    else
      memset(ValueData, 0, DataSize);
    return FALSE;
  }
  return TRUE;
}
//---------------------------------------------------------------------------
void DeleteRegKey(HKEY hRoot, char* Key)
{
  char FullKeyName[512];
  sprintf(FullKeyName, "%s%s%s", PluginRootKey, *Key ? "\\" : "", Key);
  RegDeleteKey(hRoot, FullKeyName);
}
//---------------------------------------------------------------------------
HKEY CreateRegKey(HKEY hRoot, char* Key)
{
  HKEY hKey;
  DWORD Disposition;
  char FullKeyName[512];
  sprintf(FullKeyName, "%s%s%s", PluginRootKey, *Key ? "\\" : "", Key);
  RegCreateKeyEx(hRoot, FullKeyName, 0, NULL, 0, KEY_WRITE, NULL,
                 &hKey, &Disposition);
  return hKey;
}
//---------------------------------------------------------------------------
HKEY OpenRegKey(HKEY hRoot, char* Key)
{
  HKEY hKey;
  char FullKeyName[512];
  sprintf(FullKeyName, "%s%s%s", PluginRootKey, *Key ? "\\" : "", Key);
  if(RegOpenKeyEx(hRoot,FullKeyName,0,KEY_QUERY_VALUE,&hKey) != ERROR_SUCCESS)
    return NULL;
  return hKey;
}
//---------------------------------------------------------------------------


