//---------------------------------------------------------------------------
#include "cp_class.h"
#include "cp_plug.h"
#include "cp_lng.h"
#include "cp_cfg.h"
#include <stdio.h>

#include <cpl.h>
//---------------------------------------------------------------------------
TControlPanel::TControlPanel()
{
  FFirstTime = TRUE;
  FPanelItems = NULL;
  FPanelItemsNumber = 0;
}
//---------------------------------------------------------------------------
TControlPanel::~TControlPanel()
{
  ClearItems();
}
//---------------------------------------------------------------------------
int TControlPanel::GetFindData(PluginPanelItem **pPanelItem, int *pItemsNumber, int OpMode)
{
  if(FFirstTime == TRUE)
  {
    HANDLE hScreen = g_StartupInfo.SaveScreen(0, 0, -1, -1);
    char *MsgItems[]={GetMsg(MControlPanel), GetMsg(MCPUpdate)};
    g_StartupInfo.Message(g_StartupInfo.ModuleNumber, 0, NULL, MsgItems, sizeof(MsgItems)/sizeof(MsgItems[0]), 0);

    UpdateItems();
    FFirstTime = FALSE;

//  Sort(*pPanelItem, *pItemsNumber);

    g_StartupInfo.RestoreScreen(hScreen);
  }

  *pPanelItem = FPanelItems;
  *pItemsNumber = FPanelItemsNumber;

  return TRUE;
}
//---------------------------------------------------------------------------
void TControlPanel::GetOpenPluginInfo(OpenPluginInfo *Info)
{
  Info->StructSize = sizeof(*Info);
  Info->Flags = OPIF_ADDDOTS | OPIF_SHOWNAMESONLY | OPIF_SHOWRIGHTALIGNNAMES | OPIF_SHOWPRESERVECASE;

  Info->HostFile = NULL;
  Info->CurDir = "";

  Info->Format = GetMsg(MControlPanel);

  static char Title[100];
  sprintf(Title, " %s ", GetMsg(MControlPanel));
  Info->PanelTitle = Title;

  Info->InfoLines = NULL;
  Info->InfoLinesNumber = 0;

  Info->DescrFiles = NULL;
  Info->DescrFilesNumber = 0;

  static struct PanelMode PanelModesArray[10];

  PanelModesArray[0].ColumnTypes = "N"; PanelModesArray[0].ColumnWidths = "0"; PanelModesArray[0].FullScreen = FALSE;
  PanelModesArray[1].ColumnTypes = "N"; PanelModesArray[1].ColumnWidths = "0"; PanelModesArray[1].FullScreen = FALSE;
  PanelModesArray[2].ColumnTypes = "N"; PanelModesArray[2].ColumnWidths = "0"; PanelModesArray[2].FullScreen = FALSE;
  PanelModesArray[3].ColumnTypes = "N"; PanelModesArray[3].ColumnWidths = "0"; PanelModesArray[3].FullScreen = FALSE;
  PanelModesArray[4].ColumnTypes = "N"; PanelModesArray[4].ColumnWidths = "0"; PanelModesArray[4].FullScreen = FALSE;
  PanelModesArray[5].ColumnTypes = "N"; PanelModesArray[5].ColumnWidths = "0"; PanelModesArray[5].FullScreen = FALSE;
  PanelModesArray[6].ColumnTypes = "N,Z"; PanelModesArray[6].ColumnWidths = "0,0"; PanelModesArray[6].FullScreen = FALSE;
  PanelModesArray[7].ColumnTypes = "N,Z"; PanelModesArray[7].ColumnWidths = "0,0"; PanelModesArray[7].FullScreen = TRUE;
  PanelModesArray[8].ColumnTypes = "N"; PanelModesArray[8].ColumnWidths = "0"; PanelModesArray[8].FullScreen = FALSE;
  PanelModesArray[9].ColumnTypes = "N"; PanelModesArray[9].ColumnWidths = "0"; PanelModesArray[9].FullScreen = FALSE;

  Info->PanelModesArray = PanelModesArray;
  Info->PanelModesNumber = sizeof(PanelModesArray) / sizeof(PanelModesArray[0]);
  Info->StartPanelMode = 0;

  static struct KeyBarTitles KeyBar;
  memset(&KeyBar, 0, sizeof(KeyBar));
  KeyBar.Titles[2-1] = ""; KeyBar.Titles[3-1] = ""; KeyBar.Titles[4-1] = ""; KeyBar.Titles[5-1] = "";
  KeyBar.Titles[6-1] = ""; KeyBar.Titles[7-1] = ""; KeyBar.Titles[8-1] = "";

  KeyBar.AltTitles[3-1] = ""; KeyBar.AltTitles[4-1] = ""; KeyBar.AltTitles[5-1] = ""; KeyBar.AltTitles[6-1] = "";

  KeyBar.ShiftTitles[1-1] = ""; KeyBar.ShiftTitles[2-1] = ""; KeyBar.ShiftTitles[3-1] = "";
  KeyBar.ShiftTitles[4-1] = ""; KeyBar.ShiftTitles[5-1] = ""; KeyBar.ShiftTitles[6-1] = "";
  KeyBar.ShiftTitles[8-1] = "";

  Info->KeyBar = &KeyBar;

  Info->StartSortMode = SM_NAME;
  Info->StartSortOrder = 0;
}
//---------------------------------------------------------------------------
int TControlPanel::SetDirectory(char *Dir, int OpMode)
{
//  if((OpMode & OPM_FIND) || strcmp(Dir, "\\") == 0) return FALSE;
  g_StartupInfo.Control(this, FCTL_CLOSEPLUGIN, Dir);
  return TRUE;
}
//---------------------------------------------------------------------------
int TControlPanel::ProcessKey(int Key, unsigned int ControlState)
{
  if(ControlState == 0 && Key == VK_RETURN)
  {
    PanelInfo pi;

    g_StartupInfo.Control(this, FCTL_GETPANELINFO, &pi);

    PluginPanelItem *current = (PluginPanelItem*)((BYTE*)(pi.PanelItems) + pi.CurrentItem * sizeof(PluginPanelItem));

    if((current->FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0)
      return FALSE;

    char FileName[MAX_PATH];
    sprintf(FileName, "shell32.dll,Control_RunDLL %s @%d", ((TCPlAppletData*)(current->UserData))->Filename, ((TCPlAppletData*)(current->UserData))->AppletNumber);

    ShellExecute(NULL,
                   "open",
                   "rundll32.exe",
                   FileName,
                   NULL,
                   SW_SHOWNORMAL);
    return TRUE;
  }
  return FALSE;
}
//---------------------------------------------------------------------------
BOOL TControlPanel::ProcessCPL(char *Path, WIN32_FIND_DATA &fd)
{
  const int DescriptionSize = MAX_PATH;
  char Name[MAX_PATH];

  strcpy(Name, Path); strcat(Name, fd.cFileName);

  FPanelItems = (PluginPanelItem*)realloc(FPanelItems, (FPanelItemsNumber + 1)* sizeof(PluginPanelItem));
  ZeroMemory(FPanelItems + FPanelItemsNumber, sizeof(PluginPanelItem));

  FPanelItems[FPanelItemsNumber].Flags = PPIF_USERDATA;
  FPanelItems[FPanelItemsNumber].UserData = (DWORD)calloc(1, sizeof(TCPlAppletData));

  ((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->Size = sizeof(TCPlAppletData);
  strcpy(((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->Filename, Name);
  ((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->AppletNumber = 0;

  GetFileTitle(Name, FPanelItems[FPanelItemsNumber].FindData.cFileName, MAX_PATH);
  FPanelItems[FPanelItemsNumber].Description = NULL;

  HINSTANCE hInst = LoadLibrary(Name);
  if(hInst == NULL) // possible 16bit dll.
  {
    FPanelItemsNumber++;
    return FALSE;
  }

  FARPROC proc = GetProcAddress(hInst, "CPlApplet");
  if(proc == NULL)
  {
    FPanelItemsNumber++;
    FreeLibrary(hInst);
    return FALSE;
  }

  if(((APPLET_PROC)(proc))(NULL, CPL_INIT, 0, 0) == FALSE)
  {
    FPanelItemsNumber++;
    FreeLibrary(hInst);
    return TRUE;
  }

  int Count = ((APPLET_PROC)(proc))(NULL, CPL_GETCOUNT, 0, 0);

  for(int i = 0; i < Count; i++)
  {

    CPLINFO cplInfo;
    char Buf[MAX_PATH] = { 0 };

    ((APPLET_PROC)(proc))(NULL, CPL_INQUIRE, i, (long)&cplInfo);

    if(LoadString(hInst, cplInfo.idName, Buf, MAX_PATH) != 0)
    {
      FPanelItems[FPanelItemsNumber].Description = (char*)calloc(1, DescriptionSize);
      LoadString(hInst, cplInfo.idInfo, FPanelItems[FPanelItemsNumber].Description, DescriptionSize);
      CharToOem(FPanelItems[FPanelItemsNumber].Description, FPanelItems[FPanelItemsNumber].Description);
    }
    else
    {
      NEWCPLINFO NewCplInfo;

      ((APPLET_PROC)(proc))(NULL, CPL_NEWINQUIRE, i, (long)&NewCplInfo);

      strcpy(Buf, NewCplInfo.szName);
      FPanelItems[FPanelItemsNumber].Description = (char*)calloc(strlen(NewCplInfo.szInfo), sizeof(char));
      CharToOem(NewCplInfo.szInfo, FPanelItems[FPanelItemsNumber].Description);
    }

    char *ch = strchr(Buf, '/'); //   '/',   FAR'   :(
    if(ch == NULL) strcpy(FPanelItems[FPanelItemsNumber].FindData.cFileName, Buf);
    else
    {
      *ch = 0;
      sprintf(FPanelItems[FPanelItemsNumber].FindData.cFileName, "%s & %s", Buf, ch + 1);
    }

    CharToOem(FPanelItems[FPanelItemsNumber].FindData.cFileName, FPanelItems[FPanelItemsNumber].FindData.cFileName);

    ((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->AppletNumber = i;

    FPanelItemsNumber++;

    if(i != Count - 1)
    {
      FPanelItems = (PluginPanelItem*)realloc(FPanelItems, (FPanelItemsNumber + 1)* sizeof(PluginPanelItem));
      ZeroMemory(FPanelItems + FPanelItemsNumber, sizeof(PluginPanelItem));

      FPanelItems[FPanelItemsNumber].Flags = PPIF_USERDATA;
      FPanelItems[FPanelItemsNumber].UserData = (DWORD)calloc(1, sizeof(TCPlAppletData));

      ((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->Size = sizeof(TCPlAppletData);
      strcpy(((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->Filename, Name);
      ((TCPlAppletData*)FPanelItems[FPanelItemsNumber].UserData)->AppletNumber = 0;

      GetFileTitle(Name, FPanelItems[FPanelItemsNumber].FindData.cFileName, MAX_PATH);
      FPanelItems[FPanelItemsNumber].Description = NULL;
    }
  }

  ((APPLET_PROC)(proc))(NULL, CPL_EXIT, 0, 0);
  FreeLibrary(hInst);

  return TRUE;
}
//---------------------------------------------------------------------------
void TControlPanel::UpdateItems()
{
  ClearItems();

  ReadSystemDir();
}
//---------------------------------------------------------------------------
void TControlPanel::ReadSystemDir()
{
  WIN32_FIND_DATA fd;

  char Path[MAX_PATH], Name[MAX_PATH];

  GetSystemDirectory(Path, MAX_PATH);

  if(Path[strlen(Path) - 1] != '\\')
    strcat(Path, "\\");

  strcpy(Name, Path);
  strcat(Name, "*.cpl");

  HANDLE hFind = FindFirstFile(Name, &fd);

  if(hFind != INVALID_HANDLE_VALUE)
  {
    do
    {
      if(Options.UseControlIni)
      {
        char Buf[MAX_PATH];
        GetPrivateProfileString("don't load", fd.cFileName, "yes", Buf, MAX_PATH, "control.ini");

        if(strcmpi(Buf, "no") == 0)
          continue;
      }
      ProcessCPL(Path, fd);

    }while(FindNextFile(hFind, &fd));
  }

  FindClose(hFind);
}
//---------------------------------------------------------------------------
/*
static int _cdecl SortListCmp(const void *el1, const void *el2)
{
  PluginPanelItem *Item1,*Item2;
  Item1 = (PluginPanelItem*)el1;
  Item2 = (PluginPanelItem*)el2;
  return stricmp(Item1->FindData.cFileName, Item2->FindData.cFileName);
}
void TControlPanel::Sort(PluginPanelItem *PanelItem, int Number)
{
  qsort(PanelItem, Number, sizeof(PluginPanelItem), SortListCmp);
}
//---------------------------------------------------------------------------
*/
void TControlPanel::ClearItems()
{
  for(int i = 0; i < FPanelItemsNumber; i++)
  {
    free(FPanelItems[i].Description);
    if((FPanelItems[i].Flags & PPIF_USERDATA) != 0)
      free((void*)(FPanelItems[i].UserData));
  }

  free(FPanelItems);

  FPanelItemsNumber = 0;
  FPanelItems = NULL;
}
//---------------------------------------------------------------------------
